class VirusCase {
  constructor(sex, age, dateSympStr, dateConfStr, travHistStr, travLoca) {
    this.sex = sex;
    this.age = age;
    this.dateSympStr = dateSympStr;
    this.dateConfStr = dateConfStr;
    this.travHistStr = travHistStr;
    this.travLoca = travLoca;
  }
}

class AreaStats {
    constructor(lat, lng) {
      this.maleNum = 0;
      this.femaleNum = 0;
      this.totalNum = 0;
      this.lat = lat;
      this.lng = lng;
    }
}

class AreaCases {
  constructor(lat, lng, city, country, province) {
    this.maleCases = []
    this.femaleCases = []
    this.nonsexCases = [];
    this.city = city;
    this.province = province;
    this.country = country;
    this.lat = lat;
    this.lng = lng;
  }

  add_case(vcase) {
    this.nonsexCases.push(vcase);
    if (vcase.sex == 'male')
      this.maleCases.push(vcase);
    else if (vcase.sex == 'female')
      this.femaleCases.push(vcase);   
  }
}

class DailyCases {
  constructor(date) {
    // areas: {"lat,lng": area_case}
    // date: [month, day, year]
    this.date = date
    this.areas = {};
  }

  add_case(lat, lng, city, province, country, vcase) {
    var key = '' + lat + ',' + lng + '';
    var area = this.areas[key];
    if (!area) {
      area = new AreaCases(lat, lng, city, country, province);
      this.areas[key] = area;
    }
    area.add_case(vcase);
  }
}